//+------------------------------------------------------------------+
//| RBCI_hist.mq4 
//| Ramdass - Conversion only
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrGreen
#property indicator_color2  clrRed

extern bool               ShowArrows       = true;
extern string             arrowsIdentifier = "rbci Arrows1";
extern double             arrowsUpperGap   = 1.0;
extern double             arrowsLowerGap   = 1.0;
extern color              arrowsUpColor    = clrLimeGreen;
extern color              arrowsDnColor    = clrRed;
extern int                arrowsUpCode     = 241;
extern int                arrowsDnCode     = 242;

//---- buffers
double up[];
double dn[];
double rbci[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,up); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,rbci);
   SetIndexBuffer(3,trend);
return(0);
}
int deinit() 
{  
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}

//+------------------------------------------------------------------+
//| RBCI                                                             |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
       
   //
   //
   //
   //
   //

   for (int i=limit; i>=0; i--)
   {

      double value2 = 
0.08269258*Close[i+0]
+0.08210489*Close[i+1]
+0.08093874*Close[i+2]
+0.07921003*Close[i+3]
+0.07694005*Close[i+4]
+0.07415944*Close[i+5]
+0.07090508*Close[i+6]
+0.06722010*Close[i+7]
+0.06314921*Close[i+8]
+0.05874928*Close[i+9]
+0.05407277*Close[i+10]
+0.04918011*Close[i+11]
+0.04413127*Close[i+12]
+0.03898817*Close[i+13]
+0.03381087*Close[i+14]
+0.02866037*Close[i+15]
+0.02359602*Close[i+16]
+0.01867285*Close[i+17]
+0.01394154*Close[i+18]
+0.00945020*Close[i+19]
+0.00524380*Close[i+20]
+0.00135856*Close[i+21]
-0.00217576*Close[i+22]
-0.00533362*Close[i+23]
-0.00809235*Close[i+24]
-0.01044596*Close[i+25]
-0.01238246*Close[i+26]
-0.01390515*Close[i+27]
-0.01501922*Close[i+28]
-0.01573813*Close[i+29]
-0.01607903*Close[i+30]
-0.01606501*Close[i+31]
-0.01572265*Close[i+32]
-0.01508076*Close[i+33]
-0.01417155*Close[i+34]
-0.01303199*Close[i+35]
-0.01170149*Close[i+36]
-0.01021570*Close[i+37]
-0.00860941*Close[i+38]
-0.00692232*Close[i+39]
-0.00519812*Close[i+40]
-0.00345733*Close[i+41]
-0.00174477*Close[i+42]
-0.00008354*Close[i+43]
+0.00149695*Close[i+44]
+0.00297402*Close[i+45]
+0.00432644*Close[i+46]
+0.00553786*Close[i+47]
+0.00659613*Close[i+48]
+0.00749328*Close[i+49]
+0.00822608*Close[i+50]
+0.00879528*Close[i+51]
+0.00920238*Close[i+52]
+0.00944568*Close[i+53]
+0.00952717*Close[i+54]
+0.00946588*Close[i+55]
+0.00929962*Close[i+56]
+0.00898757*Close[i+57]
+0.00859207*Close[i+58]
+0.00810829*Close[i+59]
+0.00755924*Close[i+60]
+0.00696141*Close[i+61]
+0.00633350*Close[i+62]
+0.00569343*Close[i+63]
+0.00505929*Close[i+64]
+0.00444999*Close[i+65]
+0.00388521*Close[i+66]
+0.00338555*Close[i+67]
+0.00297397*Close[i+68]
+0.00267839*Close[i+69]
+0.00253170*Close[i+70]
+0.00257620*Close[i+71]
-0.00816217*Close[i+72];

       double value1 = 
0.36423990*Close[i+0]
+0.33441085*Close[i+1]
+0.25372851*Close[i+2]
+0.14548806*Close[i+3]
+0.03934469*Close[i+4]
-0.03871426*Close[i+5]
-0.07451349*Close[i+6]
-0.06903411*Close[i+7]
-0.03611022*Close[i+8]
+0.00422528*Close[i+9]
+0.03382809*Close[i+10]
+0.04267885*Close[i+11]
+0.03120441*Close[i+12]
+0.00816037*Close[i+13]
-0.01442877*Close[i+14]
-0.02678947*Close[i+15]
-0.02525534*Close[i+16]
-0.01272910*Close[i+17]
+0.00350063*Close[i+18]
+0.01565175*Close[i+19]
+0.01895659*Close[i+20]
+0.01328613*Close[i+21]
+0.00252297*Close[i+22]
-0.00775517*Close[i+23]
-0.01301467*Close[i+24]
-0.01164808*Close[i+25]
-0.00527241*Close[i+26]
+0.00248750*Close[i+27]
+0.00793380*Close[i+28]
+0.00897632*Close[i+29]
+0.00583939*Close[i+30]
+0.00059669*Close[i+31]
-0.00405186*Close[i+32]
-0.00610944*Close[i+33]
-0.00509042*Close[i+34]
-0.00198138*Close[i+35]
+0.00144873*Close[i+36]
+0.00373774*Close[i+37]
+0.01047723*Close[i+38]
-0.00022625*Close[i+39];

      rbci[i] = value1-value2;
      up[i] = EMPTY_VALUE;
      dn[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
      if (rbci[i]>rbci[i+1]) trend[i] = 1;
      if (rbci[i]<rbci[i+1]) trend[i] =-1;
      if (trend[i] == 1)     up[i] = rbci[i];
      if (trend[i] ==-1)     dn[i] = rbci[i];
      
      //
      //
      //
      //
      //
     
      if (ShowArrows)
      {
         ObjectDelete(arrowsIdentifier+":"+Time[i]);
         if (trend[i] != trend[i+1])
         {
            if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
            if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
         }
      }
      

   }
return(0);
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool tup)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (tup)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}
